//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;

namespace DataBase
{
	/// <summary>
	/// Summary description for DataBaseMain.
	/// </summary>
	class DataBaseMain
	{
		static void Main(string[] args)
		{
			SqlConnection nwindConn = new SqlConnection("Data Source=mycomputer\\NETSDK;" +
														"Integrated Security=true;" + 
				                                        "Initial Catalog=northwind");
			SqlCommand employeesCommand = new SqlCommand("SELECT EmployeeID, LastName, FirstName, Title FROM Employees", nwindConn);
			try
			{
				nwindConn.Open();
				SqlDataReader myReader = employeesCommand.ExecuteReader();
				DataTable schemaTable = myReader.GetSchemaTable();
				foreach (DataRow myRow in schemaTable.Rows)
				{
					foreach (DataColumn myCol in schemaTable.Columns)
						Console.WriteLine(myCol.ColumnName + " = " + myRow[myCol]);
					Console.WriteLine();
				}
				do
				{
					Console.WriteLine("{0} {1} {2} {3}",
						              myReader.GetName(0),
						              myReader.GetName(1),
						              myReader.GetName(2),
						              myReader.GetName(3));

					while (myReader.Read())
						Console.WriteLine("{0} {1} {2} {3}",
							              myReader.GetInt32(0),
							              myReader.GetString(1),
							              myReader.GetString(2),
							              myReader.GetString(3));

				} while (myReader.NextResult());
				myReader.Close();
				nwindConn.Close();
			}
			catch(Exception e)
			{
				Debug.WriteLine(e);
			}
		}
	}
}
