import java.io.*;
import java.lang.*;
import java.util.*;

class DateClass implements Serializable {

    private Date d;
    private String s;

    DateClass (String s, Date d) {
		this.s = s;
		this.d = d;
    }

    public static void main(String args[]) {
		Date d = new Date();
		DateClass corg = new DateClass("This is a test", d);
		DateClass cnew = null;
		
		// Serialize the original class object
		try {
			FileOutputStream fo = new FileOutputStream("dateclass.tmp");
			ObjectOutputStream so = new ObjectOutputStream(fo);
			so.writeObject(corg);
			so.flush();
			so.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	
		// Deserialize in to new class object
		try {
			FileInputStream fi = new FileInputStream("dateclass.tmp");
			ObjectInputStream si = new ObjectInputStream(fi);  
			cnew = (DateClass) si.readObject();
			si.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	    
		// Print out to check the correctness
		System.out.println();
		System.out.println("Printing the original class...");
		System.out.println(corg);
		System.out.println();
		System.out.println("Printing the new class...");
		System.out.println(cnew);
		System.out.println();
		System.out.println("The original and new classes should be the same!");
		System.out.println();
   }
    
	// Convert the class to human readable format. Useful for debugging
    public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(s + ": ");
		sb.append(d.toString());
		return(sb.toString());
    }
}



 









