//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
namespace Polymorphism
{
	class Character
	{
		String value;
		public Character()
		{
			value = "null";
		}
		public Character(String value)
		{
			this.value = value;
		}
		public virtual void Output()
		{
			Console.WriteLine("I am a character {0}", value);
		}
	}
	class Letter : Character
	{
		public Letter(String value) : base(value)
		{
		}
		public override void Output()
		{
			Console.Write("I am a letter and ");
			base.Output();
		}
	}
	class Number : Character
	{
		public Number(String value) : base(value)
		{
		}
		public override void Output()
		{
			Console.Write("I am a number and ");
			base.Output();
		}
	}

	class CharacterOutput 
	{
		public static void Main(String[] args)
		{
			Character [] c = new Character [] { new Letter("A"),
												new Letter("B"),
												new Letter("C"),
												new Number("1"),
												new Number("2"),
												new Number("3") };
				// Enumerate command-line args array
				for(int i = 0; i < c.Length; ++i)
					c[i].Output();
		}
	}
}
