//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Text;

[Serializable()]
public class DateClass
{
    public DateTime d;
	public String s;

	public DateClass()
	{
	}
    public DateClass (String s, DateTime d)
	{
		this.s = s;
		this.d = d;
    }

    public static void Main(String [] args)
	{
		DateTime d = DateTime.Now;
		DateClass corg = new DateClass("This is a test", d);
		DateClass cnew = null;
		string filename = "dateclasssoap.xml";
		
		// Serialize the original class object
		try
		{
			// BinaryFormatter ser = new BinaryFormatter();
			SoapFormatter ser = new SoapFormatter();
			Stream writer = File.Create(filename);
			ser.Serialize(writer, corg);
			writer.Close();
		} 
		catch (Exception e)
		{
			Console.WriteLine(e);
			return;
		}
	
		// Deserialize in to new class object
		try
		{
			// BinaryFormatter ser = new BinaryFormatter();
			SoapFormatter ser = new SoapFormatter();
			Stream reader = File.OpenRead(filename);
			cnew = (DateClass)ser.Deserialize(reader);
			reader.Close();
		}
		catch (Exception e)
		{
			Console.WriteLine(e);
			return;
		}
	    
		// Print out to check the correctness
		Console.WriteLine();
		Console.WriteLine("Printing the original class...");
		Console.WriteLine(corg);
		Console.WriteLine();
		Console.WriteLine("Printing the new class...");
		Console.WriteLine(cnew);
		Console.WriteLine();
		Console.WriteLine("The original and new classes should be the same!");
		Console.WriteLine();
   }
    
	// Convert the class to human readable format. Useful for debugging
    public override string ToString()
	{
		StringBuilder sb = new StringBuilder();
		sb.Append(s + ": ");
		sb.Append(d.ToLongDateString() + " " + d.ToLongTimeString());
		return(sb.ToString());
    }
}



 









