//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
namespace Exceptions
{
	class UserDefinedException : Exception 
	{
		public UserDefinedException(String s) : base(s) { }
	}
	class TestException 
	{
		public static void Main(String[] args) 
		{
			string [] s = new string [] { "divide", "null", "array", "user" };
			for (int i = 0; i < s.Length; i++) 
			{
				try 
				{
					exceptionGenerator(s[i]);
					Console.WriteLine("TestException \"" + s[i] + "\" didn't throw an exception");
				} 
				catch (Exception e) 
				{
					Console.WriteLine("TestException \"" + s[i] + "\" threw a " + e.GetType());
					Console.WriteLine("        with message: " + e.Message);
				}
			}
		}
		static int exceptionGenerator(String s)
		{
			try 
			{
				if (s.Equals("divide")) 
				{
					int i = 0;
					return i/i;
				}
				if (s.Equals("null")) 
				{
					s = null;
					return s.Length;
				}
				if (s.Equals("array")) 
				{
					int [] ia = {1, 2 ,3 ,4};
					return ia[ia.Length];
				}
				if (s.Equals("user"))
					throw new UserDefinedException("UserDefinedException thrown from exceptionGenerator");
				return 0;
			} 
			finally 
			{
				Console.WriteLine("[exceptionGenerator(\"" + s + "\") done]");
			}
		}
	}
}
